CON

  _clkmode = xtal1+pll16x
  _xinfreq = 5_000_000
  Buf_size = 4096
  
OBJ

  sd[2] :"fsrw_shared"
  text  :"tv_text"
  
VAR
  byte Header[44]             
  long SampleRate
  long NumOfChannels
  long BitsPerSample
  long NumOfSamples
  long Filesize
  long Buf1[Buf_size]
  long counter
Dat
  Encdata byte "?"[512],0
  EncBit byte  0[8]
  Decdata byte " ",0

PUB main | ch, r1, r2, sta, bytes, encdataindex, encbitindex,decdataindex, index,x,y,char 

{----------------Activating TV--------------------}

  text.start(12)

{-If Encdata is more than 512 characters we add a-}
{---special character to the end of it to know----}
{-----------------where it ends-------------------}

'  if strsize(@encdata)<512
'    Byte[@Encdata][strsize(@encdata)]:=$FF
{  repeat x from 0 to 10
    Byte[@encdata][x]:="?"
  text.str(@encdata)}

{----------------Mounting SD card ----------------}

  sd[0].mount(0)

{-----------Reading Source file's Header----------}

  text.str(string("File sil.wav Info", 13))
  ReadHeader(string("sil.wav"))
                                           
{----------Copying header to target file----------}

  WriteHeader(string("silc.wav"))

{-----------Reading target file's Header----------}

  text.str(string("File silc.wav info",13))
  ReadHeader(string("silc.wav"))

{-Open source file for read and target for append-}

  r1:=sd[0].popen(string("sil.wav"),"r")
  GotoSampleData(string("sil.wav"))
  r2:=sd[1].popen(string("silc.wav"),"a")

{-Read Buf_size bytes to buf1 from source file and
  modify them before writing them to the target --}
    
  Encdataindex:=0
  encbitindex:=0
  x:=1
  repeat 
    text.out($00)
    text.str(string("reading buffer",13))
    ch:=sd[0].pread(@Buf1,buf_size)
    if ch<0
      text.str(string("End of file",13))
      delay_ms(500)
      quit
    else
      repeat while x<buf_size 'x from 1 to buf_size step 2
        repeat while encdataindex=<strsize(@encdata)-1
          char:=Byte[@Encdata][Encdataindex++]
          text.str(string("The "))
          text.dec(EncdataIndex)
          text.str(string(" character of Encdata is "))
          text.out(char)
          text.out(13)

'          If char==$FF
'            text.str(string("end of Encdata",13))
'            delay_ms(1000)
'            quit
'          else 
          repeat EncBitIndex from 0 to 7
            Encbit[EncBitIndex]:=(char>>(7-EncBitIndex))&%00000001
            text.str(string(" The encBit["))
            text.dec(EncBitIndex)
            text.str(string("] is "))
            text.hex((Encbit[EncBitIndex]),2)
          repeat Encbitindex from 0 to 7
            if byte[@encbit][encbitindex]==$01
              Byte[@Buf1][x]:=(Byte[@Buf1][x]&$fe)+$01
              text.str(string(" Coded $01"))
              x+=2
            else                 
              Byte[@Buf1][x]&=$fe
              text.str(string(" Coded $00"))
              x+=2
'           char:=$FF
        if encdataindex==strsize(@encdata)
          x:=buf_size
    text.str(string("Writing buffer"))
    sd[1].pwrite(@Buf1,ch)
  sd[0].pclose
  sd[1].pclose
  text.str(string("encoded",13))

Pri ReadHeader(fname)|r 
  r:=sd[0].popen(fname,"r")                   
  if (r<>0)
    repeat
  r:=sd[0].pread(@Header, 44)                              'Read the header
  SampleRate:=Header[27]<<24+Header[26]<<16+Header[25]<<8+Header[24]
  text.str(string("Sample rate      : "))
  text.dec(SampleRate)
  text.out(13)
  text.out(" ")
  NumOfChannels:=Header[23]<<8+Header[22]
  text.str(string("# of channels    : "))
  text.dec(NumOfChannels)
  text.out(13)
  text.out(" ")
  BitsPerSample:=Header[35]<<8+Header[34]
  text.str(string("Bits per sample  : "))
  text.dec(BitsPerSample)
  text.out(13)
  text.out(" ")
  Filesize:=Header[43]<<24+Header[42]<<16+Header[41]<<8+Header[40]+44
  text.str(string("File size (bytes): "))
  text.dec(FileSize)
  text.out(13)
  text.out(" ")
  NumOfSamples:=(8*(Filesize-44))/(NumOfChannels*BitsPerSample)
  text.str(string("# of Samples     : "))
  text.dec(NumOfSamples)
  text.out(13)


Pri WriteHeader(fname)|sta,bytes,r
  r := sd[1].popen(fname, "w")
  sta := cnt
  bytes := 0
  sd[1].pwrite(@Header,44)

Pri GotoSampleData(fname)|r
  r:=sd[0].popen(fname,"r")
  repeat 44
    r:=sd[0].pgetc

Pri Gotoxy(x,y)
  text.out($0A)
  text.out(x)
  text.out($0B)
  text.out(y)

Pri Decode(size)|i, ddi, dbi
  dbi:=0
  repeat ddi from 0 to size-1
    DecData[ddi]:=encbit[dbi]<<7+encbit[dbi+1]<<6+encbit[dbi+2]<<5+encbit[dbi+3]<<4+encbit[dbi+4]<<3+encbit[dbi+5]<<2+encbit[dbi+6]<<1+encbit[dbi+7]
'    dbi+=7
  
PRI delay_ms(Duration)                                  
  waitcnt(((clkfreq / 1_000 * Duration - 3932)) + cnt)  